org.springframework.jdbc.core.support

## Class AbstractLobStreamingResultSetExtractor<T>

- java.lang.Object
- - org.springframework.jdbc.core.support.AbstractLobStreamingResultSetExtractor<T>

- Type Parameters:
    `T` - the result type
  All Implemented Interfaces:
    ResultSetExtractor<T>

      public abstract class AbstractLobStreamingResultSetExtractor<T>
      extends Object
      implements ResultSetExtractor<T>

  Abstract ResultSetExtractor implementation that assumes streaming of LOB data. Typically used as inner class, with access to surrounding method arguments.

  Delegates to the `streamData` template method for streaming LOB content to some OutputStream, typically using a LobHandler. Converts an IOException thrown during streaming to a LobRetrievalFailureException.

  A usage example with JdbcTemplate:

      JdbcTemplate jdbcTemplate = new JdbcTemplate(dataSource);  // reusable object
       final LobHandler lobHandler = new DefaultLobHandler();  // reusable object

       jdbcTemplate.query(
                 "SELECT content FROM imagedb WHERE image_name=?", new Object[] {name},
                 new AbstractLobStreamingResultSetExtractor() {
                   public void streamData(ResultSet rs) throws SQLException, IOException {
               FileCopyUtils.copy(lobHandler.getBlobAsBinaryStream(rs, 1), contentStream);
             }
           });

  Since:
    1.0.2
  Author:
    Juergen Hoeller
  See Also:
    `LobHandler`, `LobRetrievalFailureException`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractLobStreamingResultSetExtractor()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `T` | `extractData(ResultSet rs)` Delegates to handleNoRowFound, handleMultipleRowsFound and streamData, according to the ResultSet state.
    `protected void` | `handleMultipleRowsFound()` Handle the case where the ResultSet contains multiple rows.
    `protected void` | `handleNoRowFound()` Handle the case where the ResultSet does not contain a row.
    `protected abstract void` | `streamData(ResultSet rs)` Stream LOB content from the given ResultSet to some OutputStream.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AbstractLobStreamingResultSetExtractor

          public AbstractLobStreamingResultSetExtractor()

  - ### Method Detail

    - #### extractData

          @Nullable
          public final T extractData(ResultSet rs)
                                        throws SQLException,
                                               DataAccessException

      Delegates to handleNoRowFound, handleMultipleRowsFound and streamData, according to the ResultSet state. Converts an IOException thrown by streamData to a LobRetrievalFailureException.
      Specified by:
        `extractData` in interface `ResultSetExtractor<T>`
      Parameters:
        `rs` - the ResultSet to extract data from. Implementations should not close this: it will be closed by the calling JdbcTemplate.
      Returns:
        an arbitrary result object, or `null` if none (the extractor will typically be stateful in the latter case).
      Throws:
        `SQLException` - if an SQLException is encountered getting column values or navigating (that is, there's no need to catch SQLException)
        `DataAccessException` - in case of custom exceptions
      See Also:
        `handleNoRowFound()`, `handleMultipleRowsFound()`, `streamData(java.sql.ResultSet)`, `LobRetrievalFailureException`

    - #### handleNoRowFound

          protected void handleNoRowFound()
                                   throws DataAccessException

      Handle the case where the ResultSet does not contain a row.
      Throws:
        `DataAccessException` - a corresponding exception, by default an EmptyResultDataAccessException
      See Also:
        `EmptyResultDataAccessException`

    - #### handleMultipleRowsFound

          protected void handleMultipleRowsFound()
                                          throws DataAccessException

      Handle the case where the ResultSet contains multiple rows.
      Throws:
        `DataAccessException` - a corresponding exception, by default an IncorrectResultSizeDataAccessException
      See Also:
        `IncorrectResultSizeDataAccessException`

    - #### streamData

          protected abstract void streamData(ResultSet rs)
                                      throws SQLException,
                                             IOException,
                                             DataAccessException

      Stream LOB content from the given ResultSet to some OutputStream.

      Typically used as inner class, with access to surrounding method arguments and to a LobHandler instance variable of the surrounding class.

      Parameters:
        `rs` - the ResultSet to take the LOB content from
      Throws:
        `SQLException` - if thrown by JDBC methods
        `IOException` - if thrown by stream access methods
        `DataAccessException` - in case of custom exceptions
      See Also:
        `LobHandler.getBlobAsBinaryStream(java.sql.ResultSet, java.lang.String)`, `FileCopyUtils`